/** Example of Apemanfile.js */

'use strict'

const co = require('co')

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  get $api () {
    const sign = require('apeman-api-sign')
    const session = require('apeman-api-middleware-session')
    const debug = require('debug')('my-project:api')
    const { db } = this.$ctx
    return {
      // Define APIs
      'sign': sign(),
      // Called before method invocation
      $before () {
        const s = this
        let { module, method, params } = s.state.invocation
        debug(`${module}.${method} with params: ${params}`)
      },
      // Called after method invocation
      $after () {
        let s = this
        let { module, method, returns } = s.state.invocation
        debug(`${module}.${method} with returns: ${returns}`)
      },
      // Koa middlewares
      $middlewares: [
        session(db.models.Session)
      ],
      // You can define custom scope with `@` prefix
      '@admin': {
        user: {
          destroy (id) { /* ... */ }
        }
      }
    }
  }
}
