'use strict'

const apemanfile = require('apemanfile')
const co = require('co')
const apiServer = require('./api/api_server')
const logger = require('./logger')

/** @lends apemanApi */
function apemanApi (options = {}) {
  let {
    port = 3000,
    configuration
  } = options

  let { $api } = apemanfile(configuration || null)
  return co(function * () {
    let server = yield apiServer($api, {})
    yield server.listen(port)
    Object.assign(server, { port })

    logger.notice(`server listening at port: ${port}`)
    return server
  })
}

module.exports = apemanApi
